/*
 * IncFile1.h
 *
 * Created: 18/09/2013 19:42:44
 *  Author: Xavi
 */ 


#ifndef CAPCALERA_H_
#define CAPCALERA_H_

#define F_CPU 16000000UL
#include <avr/io.h>
#include <util/delay.h>
#include <SPI.h>
#include <w5100.h>
#include <socket.h>
#include <avr/interrupt.h>
#include <string.h>
#include <avr/eeprom.h>
#include <definicions.h>

#define port_artnet 6454



void iniciar_dades_web();
void actualitzar_eeprom(uint8_t mode);
void formatejar_addr_8(unsigned char* addr, uint8_t num);
void formatejar_addr_16(uint16_t* addr, uint8_t num);

void reinici_valors();
void iniciar_sockets();
void enviar_pollreply();
int comprovar_tipus();
void omplir_pollreply ();
void envia_dmx_0();
void envia_dmx_1();
void omplir_ipprogreply();

void iniciar_usart();

void iniciar_w5100(uint8_t *mac, uint8_t *ip_address, uint8_t *gateway, uint8_t *mask);
void iniciar_udp(uint16_t port);
int extreure_udp();
int llegir_udp();
int llegir_udp(unsigned char* buffer, size_t len);
void flush_udp();
int inici_paquet_udp(uint8_t *ip, uint16_t port);
int terminar_paquet_udp();
size_t escriure_udp(uint8_t byte);
size_t escriure_udp(const uint8_t *buffer, size_t size);
void iniciar_tcp();
void enviar_tcp(const uint8_t *buf,uint16_t buflen);
void rebre_tcp(uint8_t *buf,uint16_t buflen);
int cerca_str(char *s,char *t);


#endif /* INCFILE1_H_ */